/*----- PROTECTED REGION ID(PLCRack3.cpp) ENABLED START -----*/
/* clang-format on */
//=============================================================================
//
// file :        PLCRack3.cpp
//
// description : C++ source for the PLCRack3 class and its commands.
//               The class is derived from Device. It represents the
//               CORBA servant object which will be accessed from the
//               network. All commands which can be executed on the
//               PLCRack3 are implemented in this file.
//
// project :     PLCRack3
//
// This file is part of Tango device class.
//
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
//
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include "PLCRack3.h"
#include "PLCRack3Class.h"
#include "plcsrvthread.h"
#include <iomanip>      //used for debug dump of db
#include <netdb.h>
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	PLCRack3.cpp

/**
 *  PLCRack3 class description:
 *    PLC Rack Triplo
 */

//================================================================
//  The following table gives the correspondence
//  between command and method names.
//
//  Command name  |  Method name
//================================================================
//  State         |  Inherited (no method)
//  Status        |  Inherited (no method)
//================================================================

//================================================================
//  Attributes managed are:
//================================================================
//  sezione2Temp         |  Tango::DevDouble	Scalar
//  sezione1Temp         |  Tango::DevDouble	Scalar
//  buncherTemp          |  Tango::DevDouble	Scalar
//  sezione2State        |  Tango::DevBoolean	Scalar
//  sezione1State        |  Tango::DevBoolean	Scalar
//  buncherState         |  Tango::DevBoolean	Scalar
//  sezione2FSHighState  |  Tango::DevBoolean	Scalar
//  sezione2TSState      |  Tango::DevBoolean	Scalar
//  sezione1FSHighState  |  Tango::DevBoolean	Scalar
//  sezione1TSState      |  Tango::DevBoolean	Scalar
//  buncherFSHighState   |  Tango::DevBoolean	Scalar
//  buncherTSState       |  Tango::DevBoolean	Scalar
//  sezione2FSLowState   |  Tango::DevBoolean	Scalar
//  sezione1FSLowState   |  Tango::DevBoolean	Scalar
//  buncherFSLowState    |  Tango::DevBoolean	Scalar
//================================================================

namespace PLCRack3_ns
{
/*----- PROTECTED REGION ID(PLCRack3::namespace_starting) ENABLED START -----*/
/* clang-format on */
//	static initializations
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	PLCRack3::namespace_starting

//--------------------------------------------------------
/**
 *	Method     : PLCRack3::PLCRack3()
 *	Description: Constructors for a Tango device
 *                implementing the classPLCRack3
 */
//--------------------------------------------------------
PLCRack3::PLCRack3(Tango::DeviceClass *cl, std::string &s)
 : Socket2Client(cl, s.c_str())
{
	/*----- PROTECTED REGION ID(PLCRack3::constructor_1) ENABLED START -----*/
	/* clang-format on */
	init_device();
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3::constructor_1
}
//--------------------------------------------------------
PLCRack3::PLCRack3(Tango::DeviceClass *cl, const char *s)
 : Socket2Client(cl, s)
{
	/*----- PROTECTED REGION ID(PLCRack3::constructor_2) ENABLED START -----*/
	/* clang-format on */
	init_device();
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3::constructor_2
}
//--------------------------------------------------------
PLCRack3::PLCRack3(Tango::DeviceClass *cl, const char *s, const char *d)
 : Socket2Client(cl, s, d)
{
	/*----- PROTECTED REGION ID(PLCRack3::constructor_3) ENABLED START -----*/
	/* clang-format on */
	init_device();
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3::constructor_3
}
//--------------------------------------------------------
PLCRack3::~PLCRack3()
{
	delete_device();
}

//--------------------------------------------------------
/**
 *	Method     : PLCRack3::delete_device()
 *	Description: will be called at device destruction or at init command
 */
//--------------------------------------------------------
void PLCRack3::delete_device()
{
	DEBUG_STREAM << "PLCRack3::delete_device() " << device_name << std::endl;
	/*----- PROTECTED REGION ID(PLCRack3::delete_device) ENABLED START -----*/
	/* clang-format on */
	//	Delete device allocated objects
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3::delete_device
	delete[] attr_sezione2Temp_read;
	delete[] attr_sezione1Temp_read;
	delete[] attr_buncherTemp_read;
	delete[] attr_sezione2State_read;
	delete[] attr_sezione1State_read;
	delete[] attr_buncherState_read;
	delete[] attr_sezione2FSHighState_read;
	delete[] attr_sezione2TSState_read;
	delete[] attr_sezione1FSHighState_read;
	delete[] attr_sezione1TSState_read;
	delete[] attr_buncherFSHighState_read;
	delete[] attr_buncherTSState_read;
	delete[] attr_sezione2FSLowState_read;
	delete[] attr_sezione1FSLowState_read;
	delete[] attr_buncherFSLowState_read;

	if (Tango::Util::instance()->is_svr_shutting_down()==false  &&
		Tango::Util::instance()->is_device_restarting(device_name)==false &&
		Tango::Util::instance()->is_svr_starting()==false)
	{
		//	If not shutting down call delete device for inherited object
		Socket2Client_ns::Socket2Client::delete_device();
	}
}

//--------------------------------------------------------
/**
 *	Method     : PLCRack3::init_device()
 *	Description: will be called at device initialization.
 */
//--------------------------------------------------------
void PLCRack3::init_device()
{
	DEBUG_STREAM << "PLCRack3::init_device() create device " << device_name << std::endl;
	/*----- PROTECTED REGION ID(PLCRack3::init_device_before) ENABLED START -----*/
	/* clang-format on */
	//	Initialization before get_device_property() call
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3::init_device_before

	if (Tango::Util::instance()->is_svr_starting() == false  &&
		Tango::Util::instance()->is_device_restarting(device_name)==false)
	{
		//	If not starting up call init device for inherited object
		Socket2Client_ns::Socket2Client::init_device();
	}
	//	No device property to be read from database

	attr_sezione2Temp_read = new Tango::DevDouble[1];
	attr_sezione1Temp_read = new Tango::DevDouble[1];
	attr_buncherTemp_read = new Tango::DevDouble[1];
	attr_sezione2State_read = new Tango::DevBoolean[1];
	attr_sezione1State_read = new Tango::DevBoolean[1];
	attr_buncherState_read = new Tango::DevBoolean[1];
	attr_sezione2FSHighState_read = new Tango::DevBoolean[1];
	attr_sezione2TSState_read = new Tango::DevBoolean[1];
	attr_sezione1FSHighState_read = new Tango::DevBoolean[1];
	attr_sezione1TSState_read = new Tango::DevBoolean[1];
	attr_buncherFSHighState_read = new Tango::DevBoolean[1];
	attr_buncherTSState_read = new Tango::DevBoolean[1];
	attr_sezione2FSLowState_read = new Tango::DevBoolean[1];
	attr_sezione1FSLowState_read = new Tango::DevBoolean[1];
	attr_buncherFSLowState_read = new Tango::DevBoolean[1];
	//	No longer if mandatory property not set.
	if (mandatoryNotDefined)
		return;

	/*----- PROTECTED REGION ID(PLCRack3::init_device) ENABLED START -----*/
	/* clang-format on */
	//	Initialize device
	loop = new plcsrvthread(this);
	loop->start();
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3::init_device
}


//--------------------------------------------------------
/**
 *	Method     : PLCRack3::always_executed_hook()
 *	Description: method always executed before any command is executed
 */
//--------------------------------------------------------
void PLCRack3::always_executed_hook()
{
	DEBUG_STREAM << "PLCRack3::always_executed_hook()  " << device_name << std::endl;
	if (mandatoryNotDefined)
	{
		Tango::Except::throw_exception(
					(const char *)"PROPERTY_NOT_SET",
					get_status().c_str(),
					(const char *)"PLCRack3::always_executed_hook()");
	}
	/*----- PROTECTED REGION ID(PLCRack3::always_executed_hook) ENABLED START -----*/
	/* clang-format on */
	//	code always executed before all requests
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3::always_executed_hook
}

//--------------------------------------------------------
/**
 *	Method     : PLCRack3::read_attr_hardware()
 *	Description: Hardware acquisition for attributes
 */
//--------------------------------------------------------
void PLCRack3::read_attr_hardware(TANGO_UNUSED(std::vector<long> &attr_list))
{
	DEBUG_STREAM << "PLCRack3::read_attr_hardware(std::vector<long> &attr_list) entering... " << std::endl;
	/*----- PROTECTED REGION ID(PLCRack3::read_attr_hardware) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3::read_attr_hardware
}
//--------------------------------------------------------
/**
 *	Method     : PLCRack3::write_attr_hardware()
 *	Description: Hardware writing for attributes
 */
//--------------------------------------------------------
void PLCRack3::write_attr_hardware(TANGO_UNUSED(std::vector<long> &attr_list))
{
	DEBUG_STREAM << "PLCRack3::write_attr_hardware(std::vector<long> &attr_list) entering... " << std::endl;
	/*----- PROTECTED REGION ID(PLCRack3::write_attr_hardware) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3::write_attr_hardware
}

//--------------------------------------------------------
/**
 *	Read attribute sezione2Temp related method
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void PLCRack3::read_sezione2Temp(Tango::Attribute &attr)
{
	DEBUG_STREAM << "PLCRack3::read_sezione2Temp(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(PLCRack3::read_sezione2Temp) ENABLED START -----*/
	/* clang-format on */
	//	Set the attribute value
	*attr_sezione2Temp_read = (double)(ntohs(db500.temp_sez2))/100.0;
	attr.set_value(attr_sezione2Temp_read);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3::read_sezione2Temp
}
//--------------------------------------------------------
/**
 *	Read attribute sezione1Temp related method
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void PLCRack3::read_sezione1Temp(Tango::Attribute &attr)
{
	DEBUG_STREAM << "PLCRack3::read_sezione1Temp(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(PLCRack3::read_sezione1Temp) ENABLED START -----*/
	/* clang-format on */
	//	Set the attribute value
	*attr_sezione1Temp_read = (double)(ntohs(db500.temp_sez1))/100.0;
	attr.set_value(attr_sezione1Temp_read);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3::read_sezione1Temp
}
//--------------------------------------------------------
/**
 *	Read attribute buncherTemp related method
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void PLCRack3::read_buncherTemp(Tango::Attribute &attr)
{
	DEBUG_STREAM << "PLCRack3::read_buncherTemp(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(PLCRack3::read_buncherTemp) ENABLED START -----*/
	/* clang-format on */
	//	Set the attribute value
	*attr_buncherTemp_read = (double)(ntohs(db500.temp_buncher))/100.0;
	attr.set_value(attr_buncherTemp_read);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3::read_buncherTemp
}
//--------------------------------------------------------
/**
 *	Read attribute sezione2State related method
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void PLCRack3::read_sezione2State(Tango::Attribute &attr)
{
	DEBUG_STREAM << "PLCRack3::read_sezione2State(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(PLCRack3::read_sezione2State) ENABLED START -----*/
	/* clang-format on */
	//	Set the attribute value
	*attr_sezione2State_read = (Tango::DevBoolean)(db500.stato_sez2 != 0);
	attr.set_value(attr_sezione2State_read);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3::read_sezione2State
}
//--------------------------------------------------------
/**
 *	Write attribute sezione2State related method
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void PLCRack3::write_sezione2State(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "PLCRack3::write_sezione2State(Tango::WAttribute &attr) entering... " << std::endl;
	//	Retrieve write value
	Tango::DevBoolean	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(PLCRack3::write_sezione2State) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	if(w_val)
		send_cmd(StartSez2Cmd);
	else
		send_cmd(StopSez2Cmd);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3::write_sezione2State
}
//--------------------------------------------------------
/**
 *	Read attribute sezione1State related method
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void PLCRack3::read_sezione1State(Tango::Attribute &attr)
{
	DEBUG_STREAM << "PLCRack3::read_sezione1State(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(PLCRack3::read_sezione1State) ENABLED START -----*/
	/* clang-format on */
	//	Set the attribute value
	*attr_sezione1State_read = (Tango::DevBoolean)(db500.stato_sez1 != 0);
	attr.set_value(attr_sezione1State_read);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3::read_sezione1State
}
//--------------------------------------------------------
/**
 *	Write attribute sezione1State related method
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void PLCRack3::write_sezione1State(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "PLCRack3::write_sezione1State(Tango::WAttribute &attr) entering... " << std::endl;
	//	Retrieve write value
	Tango::DevBoolean	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(PLCRack3::write_sezione1State) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	if(w_val)
		send_cmd(StartSez1Cmd);
	else
		send_cmd(StopSez1Cmd);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3::write_sezione1State
}
//--------------------------------------------------------
/**
 *	Read attribute buncherState related method
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void PLCRack3::read_buncherState(Tango::Attribute &attr)
{
	DEBUG_STREAM << "PLCRack3::read_buncherState(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(PLCRack3::read_buncherState) ENABLED START -----*/
	/* clang-format on */
	//	Set the attribute value
	*attr_buncherState_read = (Tango::DevBoolean)(db500.stato_buncher != 0);
	attr.set_value(attr_buncherState_read);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3::read_buncherState
}
//--------------------------------------------------------
/**
 *	Write attribute buncherState related method
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void PLCRack3::write_buncherState(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "PLCRack3::write_buncherState(Tango::WAttribute &attr) entering... " << std::endl;
	//	Retrieve write value
	Tango::DevBoolean	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(PLCRack3::write_buncherState) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	if(w_val)
		send_cmd(StartBuncherCmd);
	else
		send_cmd(StopBuncherCmd);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3::write_buncherState
}
//--------------------------------------------------------
/**
 *	Read attribute sezione2FSHighState related method
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void PLCRack3::read_sezione2FSHighState(Tango::Attribute &attr)
{
	DEBUG_STREAM << "PLCRack3::read_sezione2FSHighState(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(PLCRack3::read_sezione2FSHighState) ENABLED START -----*/
	/* clang-format on */
	//	Set the attribute value
	*attr_sezione2FSHighState_read = (Tango::DevBoolean)(db500.limite_superiore_portata2 != 0);
	attr.set_value(attr_sezione2FSHighState_read);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3::read_sezione2FSHighState
}
//--------------------------------------------------------
/**
 *	Read attribute sezione2TSState related method
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void PLCRack3::read_sezione2TSState(Tango::Attribute &attr)
{
	DEBUG_STREAM << "PLCRack3::read_sezione2TSState(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(PLCRack3::read_sezione2TSState) ENABLED START -----*/
	/* clang-format on */
	//	Set the attribute value
	*attr_sezione2TSState_read = (Tango::DevBoolean)(db500.termostato_resistenza2 != 0);
	attr.set_value(attr_sezione2TSState_read);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3::read_sezione2TSState
}
//--------------------------------------------------------
/**
 *	Read attribute sezione1FSHighState related method
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void PLCRack3::read_sezione1FSHighState(Tango::Attribute &attr)
{
	DEBUG_STREAM << "PLCRack3::read_sezione1FSHighState(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(PLCRack3::read_sezione1FSHighState) ENABLED START -----*/
	/* clang-format on */
	//	Set the attribute value
	*attr_sezione1FSHighState_read = (Tango::DevBoolean)(db500.limite_superiore_portata1 != 0);
	attr.set_value(attr_sezione1FSHighState_read);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3::read_sezione1FSHighState
}
//--------------------------------------------------------
/**
 *	Read attribute sezione1TSState related method
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void PLCRack3::read_sezione1TSState(Tango::Attribute &attr)
{
	DEBUG_STREAM << "PLCRack3::read_sezione1TSState(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(PLCRack3::read_sezione1TSState) ENABLED START -----*/
	/* clang-format on */
	//	Set the attribute value
	*attr_sezione1TSState_read = (Tango::DevBoolean)(db500.termostato_resistenza1 != 0);
	attr.set_value(attr_sezione1TSState_read);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3::read_sezione1TSState
}
//--------------------------------------------------------
/**
 *	Read attribute buncherFSHighState related method
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void PLCRack3::read_buncherFSHighState(Tango::Attribute &attr)
{
	DEBUG_STREAM << "PLCRack3::read_buncherFSHighState(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(PLCRack3::read_buncherFSHighState) ENABLED START -----*/
	/* clang-format on */
	//	Set the attribute value
	*attr_buncherFSHighState_read = (Tango::DevBoolean)(db500.limite_superiore_portata3 != 0);
	attr.set_value(attr_buncherFSHighState_read);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3::read_buncherFSHighState
}
//--------------------------------------------------------
/**
 *	Read attribute buncherTSState related method
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void PLCRack3::read_buncherTSState(Tango::Attribute &attr)
{
	DEBUG_STREAM << "PLCRack3::read_buncherTSState(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(PLCRack3::read_buncherTSState) ENABLED START -----*/
	/* clang-format on */
	//	Set the attribute value
	*attr_buncherTSState_read = (Tango::DevBoolean)(db500.termostato_resistenza3 != 0);
	attr.set_value(attr_buncherTSState_read);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3::read_buncherTSState
}
//--------------------------------------------------------
/**
 *	Read attribute sezione2FSLowState related method
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void PLCRack3::read_sezione2FSLowState(Tango::Attribute &attr)
{
	DEBUG_STREAM << "PLCRack3::read_sezione2FSLowState(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(PLCRack3::read_sezione2FSLowState) ENABLED START -----*/
	/* clang-format on */
	//	Set the attribute value
	*attr_sezione2FSLowState_read = (Tango::DevBoolean)(db500.limite_inferiore_portata2 != 0);
	attr.set_value(attr_sezione2FSLowState_read);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3::read_sezione2FSLowState
}
//--------------------------------------------------------
/**
 *	Read attribute sezione1FSLowState related method
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void PLCRack3::read_sezione1FSLowState(Tango::Attribute &attr)
{
	DEBUG_STREAM << "PLCRack3::read_sezione1FSLowState(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(PLCRack3::read_sezione1FSLowState) ENABLED START -----*/
	/* clang-format on */
	//	Set the attribute value
	*attr_sezione1FSLowState_read = (Tango::DevBoolean)(db500.limite_inferiore_portata1 != 0);
	attr.set_value(attr_sezione1FSLowState_read);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3::read_sezione1FSLowState
}
//--------------------------------------------------------
/**
 *	Read attribute buncherFSLowState related method
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void PLCRack3::read_buncherFSLowState(Tango::Attribute &attr)
{
	DEBUG_STREAM << "PLCRack3::read_buncherFSLowState(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(PLCRack3::read_buncherFSLowState) ENABLED START -----*/
	/* clang-format on */
	//	Set the attribute value
	*attr_buncherFSLowState_read = (Tango::DevBoolean)(db500.limite_inferiore_buncher != 0);
	attr.set_value(attr_buncherFSLowState_read);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3::read_buncherFSLowState
}

//--------------------------------------------------------
/**
 *	Method     : PLCRack3::add_dynamic_attributes()
 *	Description: Create the dynamic attributes if any
 *                for specified device.
 */
//--------------------------------------------------------
void PLCRack3::add_dynamic_attributes()
{
	/*----- PROTECTED REGION ID(PLCRack3::add_dynamic_attributes) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code to create and add dynamic attributes if any
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3::add_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method     : PLCRack3::add_dynamic_commands()
 *	Description: Create the dynamic commands if any
 *                for specified device.
 */
//--------------------------------------------------------
void PLCRack3::add_dynamic_commands()
{
	/*----- PROTECTED REGION ID(PLCRack3::add_dynamic_commands) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code to create and add dynamic commands if any
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3::add_dynamic_commands
}

/*----- PROTECTED REGION ID(PLCRack3::namespace_ending) ENABLED START -----*/
/* clang-format on */
//	Additional Methods
void PLCRack3::send_cmd (uint16_t cmd)
{
	cmd_t prepared_cmd;
	memset(&prepared_cmd, 0, sizeof(cmd_t));
	prepared_cmd.db_number=htons(cmd);
	try {
		send_frame((unsigned char *)&prepared_cmd, sizeof(cmd_t));
	}
	catch(Tango::DevFailed e) {
		set_state(Tango::FAULT);
		set_status("Write command failed");
		Tango::Except::re_throw_exception(e,
			(const char *) "write error",
			(const char *) "write cmd error",
			(const char *) "PLCRack3::send_cmd", Tango::ERR);
	}
}
void PLCRack3::send_frame (unsigned char *query, size_t query_length)
{

	for(size_t k=0;k<query_length;)
	{
		stringstream tmp;
		size_t g;
		tmp << "dbTX: "<<setw(3)<<setfill(' ')<<k<<" -> ";
		for(g=0; g<10; g++)
		{
			if(k+g>=query_length)
				break;
			tmp << " " <<hex<<setw(2)<<setfill(' ')<< (int)(unsigned char)query[k+g];
		}
		k+=g;
		if(k<query_length)
		{
			tmp << " |  "<<dec<<setw(3)<<setfill(' ')<<k<<hex<<" -> ";
			for(g=0; g<10; g++)
			{
				if(k+g>=query_length)
					break;
				tmp << " " <<hex<<setw(2)<<setfill(' ')<< (int)(unsigned char)query[k+g];
			}
			k+=g;
		}
		DEBUG_STREAM<<tmp.str()<<dec<<endl;
	}

	vector<unsigned char> dtw;
	dtw.reserve(query_length);
	for (unsigned int i=0; i<query_length; ++i)
		dtw.push_back(query[i]);

	write(dtw);
}
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	PLCRack3::namespace_ending
} //	namespace
