/*----- PROTECTED REGION ID(PLCRack3.h) ENABLED START -----*/
/* clang-format on */
//=============================================================================
//
// file :        PLCRack3.h
//
// description : Include file for the PLCRack3 class
//
// project :     PLCRack3
//
// This file is part of Tango device class.
//
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
//
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef PLCRack3_H
#define PLCRack3_H

#include <tango.h>
#include <Socket2Client.h>

/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	PLCRack3.h

#ifdef TANGO_LOG
	// cppTango after c934adea (Merge branch 'remove-cout-definition' into 'main', 2022-05-23)
	// nothing to do
#else
	// cppTango 9.3-backports and older
	#define TANGO_LOG       cout
	#define TANGO_LOG_INFO  cout2
	#define TANGO_LOG_DEBUG cout3
#endif // TANGO_LOG

constexpr uint16_t StartSez1Cmd=200;
constexpr uint16_t StartSez2Cmd=201;
constexpr uint16_t StartBuncherCmd=202;
constexpr uint16_t StopSez1Cmd=210;
constexpr uint16_t StopSez2Cmd=211;
constexpr uint16_t StopBuncherCmd=212;

/**
 *  PLCRack3 class description:
 *    PLC Rack Triplo
 */


namespace PLCRack3_ns
{
/*----- PROTECTED REGION ID(PLCRack3::Additional Class Declarations) ENABLED START -----*/
/* clang-format on */
class plcsrvthread;
//	Additional Class Declarations
#pragma pack(push,1)	// exact fit - no padding

typedef struct
{
	uint8_t timestamp[8];
} date_and_time_t;

typedef struct
{
	int16_t db_number;
	date_and_time_t db_time;
} header_t;

//DB XX
//typedef struct
//{
//	int16_t db_number;
//	date_and_time_t db_time;
//	uint16_t code;
//} cmd_t;

//DB XX
typedef struct
{
	int16_t db_number;
	date_and_time_t db_time;
	uint16_t temp_sez1;
	uint16_t temp_sez2;
	uint16_t temp_buncher;
#if __BYTE_ORDER == __BIG_ENDIAN			
				uint8_t stato_sez2:1,					//8.7
						stato_sez1:1,
						stop_buncher:1,
						stop_sez2:1,
						stop_sez1:1,
						start_buncher:1,
						start_sez2:1,
						start_sez1:1;					//8.0
#else
				uint8_t start_sez1:1,					//8.0
						start_sez2:1,
						start_buncher:1,
						stop_sez1:1,
						stop_sez2:1,
						stop_buncher:1,
						stato_sez1:1,
						stato_sez2:1;					//8.7
#endif
#if __BYTE_ORDER == __BIG_ENDIAN			
				uint8_t termostato_resistenza1:1,		//9.7
						limite_superiore_portata3:1,
						limite_superiore_portata2:1,
						limite_superiore_portata1:1,
						limite_inferiore_buncher:1,
						limite_inferiore_portata2:1,
						limite_inferiore_portata1:1,
						stato_buncher:1;				//9.0
#else
				uint8_t stato_buncher:1,				//9.0
						limite_inferiore_portata1:1,
						limite_inferiore_portata2:1,
						limite_inferiore_buncher:1,
						limite_superiore_portata1:1,
						limite_superiore_portata2:1,
						limite_superiore_portata3:1,
						termostato_resistenza1:1;		//9.7
#endif
#if __BYTE_ORDER == __BIG_ENDIAN			
				uint8_t spare:6,						//10.2-10.7
						termostato_resistenza3:1,		//10.1
						termostato_resistenza2:1;		//10.0
#else
				uint8_t termostato_resistenza2:1,		//10.0
						termostato_resistenza3:1,		//10.1
						spare:6;						//10.2-10.7
#endif
	uint8_t spare_;
} data_t;

typedef data_t cmd_t;
#pragma pack(pop) //back to whatever the previous packing mode was
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	PLCRack3::Additional Class Declarations

class PLCRack3 : public Socket2Client_ns::Socket2Client
{

/*----- PROTECTED REGION ID(PLCRack3::Data Members) ENABLED START -----*/
/* clang-format on */
//	Add your own data members
public:
bool abortflag;
friend class plcsrvthread;
plcsrvthread *loop;
data_t db500;
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	PLCRack3::Data Members

//	Device property data members
public:

	bool	mandatoryNotDefined;

//	Attribute data members
public:
	Tango::DevDouble	*attr_sezione2Temp_read;
	Tango::DevDouble	*attr_sezione1Temp_read;
	Tango::DevDouble	*attr_buncherTemp_read;
	Tango::DevBoolean	*attr_sezione2State_read;
	Tango::DevBoolean	*attr_sezione1State_read;
	Tango::DevBoolean	*attr_buncherState_read;
	Tango::DevBoolean	*attr_sezione2FSHighState_read;
	Tango::DevBoolean	*attr_sezione2TSState_read;
	Tango::DevBoolean	*attr_sezione1FSHighState_read;
	Tango::DevBoolean	*attr_sezione1TSState_read;
	Tango::DevBoolean	*attr_buncherFSHighState_read;
	Tango::DevBoolean	*attr_buncherTSState_read;
	Tango::DevBoolean	*attr_sezione2FSLowState_read;
	Tango::DevBoolean	*attr_sezione1FSLowState_read;
	Tango::DevBoolean	*attr_buncherFSLowState_read;

//	Constructors and destructors
public:
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	PLCRack3(Tango::DeviceClass *cl,std::string &s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	PLCRack3(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	PLCRack3(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The device object destructor.
	 */
	~PLCRack3();


//	Miscellaneous methods
public:
	/*
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/*
	 *	Initialize the device
	 */
	virtual void init_device();
	/*
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();

	/*
	 *	Check if mandatory property has been set
	 */
	 void check_mandatory_property(Tango::DbDatum &class_prop, Tango::DbDatum &dev_prop);

//	Attribute methods
public:
	//--------------------------------------------------------
	/*
	 *	Method     : PLCRack3::read_attr_hardware()
	 *	Description: Hardware acquisition for attributes.
	 */
	//--------------------------------------------------------
	virtual void read_attr_hardware(std::vector<long> &attr_list);
	//--------------------------------------------------------
	/*
	 *	Method     : PLCRack3::write_attr_hardware()
	 *	Description: Hardware writing for attributes.
	 */
	//--------------------------------------------------------
	virtual void write_attr_hardware(std::vector<long> &attr_list);

/**
 *	Attribute sezione2Temp related methods
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_sezione2Temp(Tango::Attribute &attr);
	virtual bool is_sezione2Temp_allowed(Tango::AttReqType type);
/**
 *	Attribute sezione1Temp related methods
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_sezione1Temp(Tango::Attribute &attr);
	virtual bool is_sezione1Temp_allowed(Tango::AttReqType type);
/**
 *	Attribute buncherTemp related methods
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_buncherTemp(Tango::Attribute &attr);
	virtual bool is_buncherTemp_allowed(Tango::AttReqType type);
/**
 *	Attribute sezione2State related methods
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_sezione2State(Tango::Attribute &attr);
	virtual void write_sezione2State(Tango::WAttribute &attr);
	virtual bool is_sezione2State_allowed(Tango::AttReqType type);
/**
 *	Attribute sezione1State related methods
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_sezione1State(Tango::Attribute &attr);
	virtual void write_sezione1State(Tango::WAttribute &attr);
	virtual bool is_sezione1State_allowed(Tango::AttReqType type);
/**
 *	Attribute buncherState related methods
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_buncherState(Tango::Attribute &attr);
	virtual void write_buncherState(Tango::WAttribute &attr);
	virtual bool is_buncherState_allowed(Tango::AttReqType type);
/**
 *	Attribute sezione2FSHighState related methods
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_sezione2FSHighState(Tango::Attribute &attr);
	virtual bool is_sezione2FSHighState_allowed(Tango::AttReqType type);
/**
 *	Attribute sezione2TSState related methods
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_sezione2TSState(Tango::Attribute &attr);
	virtual bool is_sezione2TSState_allowed(Tango::AttReqType type);
/**
 *	Attribute sezione1FSHighState related methods
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_sezione1FSHighState(Tango::Attribute &attr);
	virtual bool is_sezione1FSHighState_allowed(Tango::AttReqType type);
/**
 *	Attribute sezione1TSState related methods
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_sezione1TSState(Tango::Attribute &attr);
	virtual bool is_sezione1TSState_allowed(Tango::AttReqType type);
/**
 *	Attribute buncherFSHighState related methods
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_buncherFSHighState(Tango::Attribute &attr);
	virtual bool is_buncherFSHighState_allowed(Tango::AttReqType type);
/**
 *	Attribute buncherTSState related methods
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_buncherTSState(Tango::Attribute &attr);
	virtual bool is_buncherTSState_allowed(Tango::AttReqType type);
/**
 *	Attribute sezione2FSLowState related methods
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_sezione2FSLowState(Tango::Attribute &attr);
	virtual bool is_sezione2FSLowState_allowed(Tango::AttReqType type);
/**
 *	Attribute sezione1FSLowState related methods
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_sezione1FSLowState(Tango::Attribute &attr);
	virtual bool is_sezione1FSLowState_allowed(Tango::AttReqType type);
/**
 *	Attribute buncherFSLowState related methods
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_buncherFSLowState(Tango::Attribute &attr);
	virtual bool is_buncherFSLowState_allowed(Tango::AttReqType type);


	//--------------------------------------------------------
	/**
	 *	Method     : PLCRack3::add_dynamic_attributes()
	 *	Description: Add dynamic attributes if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_attributes();




//	Command related methods
public:


	//--------------------------------------------------------
	/**
	 *	Method     : PLCRack3::add_dynamic_commands()
	 *	Description: Add dynamic commands if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_commands();

/*----- PROTECTED REGION ID(PLCRack3::Additional Method prototypes) ENABLED START -----*/
/* clang-format on */
//	Additional Method prototypes
Tango::DevState socket_get_state(){/*return get_state2();*/return Tango::ON;}
void send_cmd (uint16_t cmd);
void send_frame (unsigned char *query, size_t query_length);
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	PLCRack3::Additional Method prototypes
};

/*----- PROTECTED REGION ID(PLCRack3::Additional Classes Definitions) ENABLED START -----*/
/* clang-format on */
//	Additional Classes Definitions
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	PLCRack3::Additional Classes Definitions

}	//	End of namespace

#endif   //	PLCRack3_H
