/*----- PROTECTED REGION ID(PLCRack3Class.cpp) ENABLED START -----*/
/* clang-format on */
//=============================================================================
//
// file :        PLCRack3Class.cpp
//
// description : C++ source for the PLCRack3Class.
//               A singleton class derived from DeviceClass.
//               It implements the command and attribute list
//               and all properties and methods required
//               by the PLCRack3 once per process.
//
// project :     PLCRack3
//
// This file is part of Tango device class.
//
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
//
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include "PLCRack3Class.h"
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	PLCRack3Class.cpp

//-------------------------------------------------------------------
/**
 *	Create PLCRack3Class singleton and
 *	return it in a C function for Python usage
 */
//-------------------------------------------------------------------
extern "C" {
#ifdef _TG_WINDOWS_

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_PLCRack3_class(const char *name) {
		return PLCRack3_ns::PLCRack3Class::init(name);
	}
}

namespace PLCRack3_ns
{
//===================================================================
//	Initialize pointer for singleton pattern
//===================================================================
PLCRack3Class *PLCRack3Class::_instance = NULL;

//===================================================================
//	Class constants
//===================================================================
//--------------------------------------------------------
/**
 * method : 		PLCRack3Class::PLCRack3Class(std::string &s)
 * description : 	constructor for the PLCRack3Class
 *
 * @param s	The class name
 */
//--------------------------------------------------------
PLCRack3Class::PLCRack3Class(std::string &s):Socket2Client_ns::Socket2ClientClass(s)
{
	TANGO_LOG_INFO << "Entering PLCRack3Class constructor" << std::endl;
	set_default_property();
	write_class_property();

	/*----- PROTECTED REGION ID(PLCRack3Class::constructor) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3Class::constructor

	TANGO_LOG_INFO << "Leaving PLCRack3Class constructor" << std::endl;
}

//--------------------------------------------------------
/**
 * method : 		PLCRack3Class::~PLCRack3Class()
 * description : 	destructor for the PLCRack3Class
 */
//--------------------------------------------------------
PLCRack3Class::~PLCRack3Class()
{
	/*----- PROTECTED REGION ID(PLCRack3Class::destructor) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3Class::destructor

	_instance = NULL;
}


//--------------------------------------------------------
/**
 * method : 		PLCRack3Class::init
 * description : 	Create the object if not already done.
 *                  Otherwise, just return a pointer to the object
 *
 * @param	name	The class name
 */
//--------------------------------------------------------
PLCRack3Class *PLCRack3Class::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			std::string s(name);
			_instance = new PLCRack3Class(s);
		}
		catch (std::bad_alloc &)
		{
			throw;
		}
	}
	return _instance;
}

//--------------------------------------------------------
/**
 * method : 		PLCRack3Class::instance
 * description : 	Check if object already created,
 *                  and return a pointer to the object
 */
//--------------------------------------------------------
PLCRack3Class *PLCRack3Class::instance()
{
	if (_instance == NULL)
	{
		std::cerr << "Class is not initialized !!" << std::endl;
		exit(-1);
	}
	return _instance;
}



//===================================================================
//	Command execution method calls
//===================================================================

//===================================================================
//	Properties management
//===================================================================
//--------------------------------------------------------
/**
 *	Method     : PLCRack3Class::get_class_property()
 *	Description: Get the class property for specified name.
 */
//--------------------------------------------------------
Tango::DbDatum PLCRack3Class::get_class_property(std::string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, returns  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method     : PLCRack3Class::get_default_device_property()
 *	Description: Return the default value for device property.
 */
//--------------------------------------------------------
Tango::DbDatum PLCRack3Class::get_default_device_property(std::string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method     : PLCRack3Class::get_default_class_property()
 *	Description: Return the default value for class property.
 */
//--------------------------------------------------------
Tango::DbDatum PLCRack3Class::get_default_class_property(std::string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method     : PLCRack3Class::set_default_property()
 *	Description: Set default property (class and device) for wizard.
 *                For each property, add to wizard property name and description.
 *                If default value has been set, add it to wizard property and
 *                store it in a DbDatum.
 */
//--------------------------------------------------------
void PLCRack3Class::set_default_property()
{
	std::string	prop_name;
	std::string	prop_desc;
	std::string	prop_def;
	std::vector<std::string>	vect_data;

	//	Set Default Class Properties

	//	Set Default device Properties
}

//--------------------------------------------------------
/**
 *	Method     : PLCRack3Class::write_class_property()
 *	Description: Set class description fields as property in database
 */
//--------------------------------------------------------
void PLCRack3Class::write_class_property()
{
	//	First time, check if database used
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	std::string	classname = get_name();
	std::string	header;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	std::string	str_title("PLCRack3");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	std::vector<std::string>	str_desc;
	str_desc.push_back("PLC Rack Triplo");
	description << str_desc;
	data.push_back(description);

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	std::vector<std::string> inheritance;
	inheritance.push_back("TANGO_BASE_CLASS");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	get_db_class()->put_property(data);
}

//===================================================================
//	Factory methods
//===================================================================

//--------------------------------------------------------
/**
 *	Method     : PLCRack3Class::device_factory()
 *	Description: Create the device object(s)
 *                and store them in the device list
 */
//--------------------------------------------------------
void PLCRack3Class::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{
	/*----- PROTECTED REGION ID(PLCRack3Class::device_factory_before) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3Class::device_factory_before

	//	Create devices and add it into the device list
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		TANGO_LOG_DEBUG << "Device name : " << (*devlist_ptr)[i].in() << std::endl;
		device_list.push_back(new PLCRack3(this, (*devlist_ptr)[i]));
	}

	//	Manage dynamic attributes if any
	erase_dynamic_attributes(devlist_ptr, get_class_attr()->get_attr_list());

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		PLCRack3 *dev = static_cast<PLCRack3 *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}

	/*----- PROTECTED REGION ID(PLCRack3Class::device_factory_after) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3Class::device_factory_after
}
//--------------------------------------------------------
/**
 *	Method     : PLCRack3Class::attribute_factory()
 *	Description: Create the attribute object(s)
 *                and store them in the attribute list
 */
//--------------------------------------------------------
void PLCRack3Class::attribute_factory(std::vector<Tango::Attr *> &att_list)
{
	/*----- PROTECTED REGION ID(PLCRack3Class::attribute_factory_before) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3Class::attribute_factory_before
	//	Call atribute_factory for inherited class
	Socket2Client_ns::Socket2ClientClass::attribute_factory(att_list);

	//	Attribute : sezione2Temp
	sezione2TempAttrib	*sezione2temp = new sezione2TempAttrib();
	Tango::UserDefaultAttrProp	sezione2temp_prop;
	//	description	not set for sezione2Temp
	//	label	not set for sezione2Temp
	//	unit	not set for sezione2Temp
	//	standard_unit	not set for sezione2Temp
	//	display_unit	not set for sezione2Temp
	//	format	not set for sezione2Temp
	//	max_value	not set for sezione2Temp
	//	min_value	not set for sezione2Temp
	//	max_alarm	not set for sezione2Temp
	//	min_alarm	not set for sezione2Temp
	//	max_warning	not set for sezione2Temp
	//	min_warning	not set for sezione2Temp
	//	delta_t	not set for sezione2Temp
	//	delta_val	not set for sezione2Temp
	sezione2temp->set_default_properties(sezione2temp_prop);
	//	Not Polled
	sezione2temp->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(sezione2temp);

	//	Attribute : sezione1Temp
	sezione1TempAttrib	*sezione1temp = new sezione1TempAttrib();
	Tango::UserDefaultAttrProp	sezione1temp_prop;
	//	description	not set for sezione1Temp
	//	label	not set for sezione1Temp
	//	unit	not set for sezione1Temp
	//	standard_unit	not set for sezione1Temp
	//	display_unit	not set for sezione1Temp
	//	format	not set for sezione1Temp
	//	max_value	not set for sezione1Temp
	//	min_value	not set for sezione1Temp
	//	max_alarm	not set for sezione1Temp
	//	min_alarm	not set for sezione1Temp
	//	max_warning	not set for sezione1Temp
	//	min_warning	not set for sezione1Temp
	//	delta_t	not set for sezione1Temp
	//	delta_val	not set for sezione1Temp
	sezione1temp->set_default_properties(sezione1temp_prop);
	//	Not Polled
	sezione1temp->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(sezione1temp);

	//	Attribute : buncherTemp
	buncherTempAttrib	*bunchertemp = new buncherTempAttrib();
	Tango::UserDefaultAttrProp	bunchertemp_prop;
	//	description	not set for buncherTemp
	//	label	not set for buncherTemp
	//	unit	not set for buncherTemp
	//	standard_unit	not set for buncherTemp
	//	display_unit	not set for buncherTemp
	//	format	not set for buncherTemp
	//	max_value	not set for buncherTemp
	//	min_value	not set for buncherTemp
	//	max_alarm	not set for buncherTemp
	//	min_alarm	not set for buncherTemp
	//	max_warning	not set for buncherTemp
	//	min_warning	not set for buncherTemp
	//	delta_t	not set for buncherTemp
	//	delta_val	not set for buncherTemp
	bunchertemp->set_default_properties(bunchertemp_prop);
	//	Not Polled
	bunchertemp->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(bunchertemp);

	//	Attribute : sezione2State
	sezione2StateAttrib	*sezione2state = new sezione2StateAttrib();
	Tango::UserDefaultAttrProp	sezione2state_prop;
	//	description	not set for sezione2State
	//	label	not set for sezione2State
	//	unit	not set for sezione2State
	//	standard_unit	not set for sezione2State
	//	display_unit	not set for sezione2State
	//	format	not set for sezione2State
	//	max_value	not set for sezione2State
	//	min_value	not set for sezione2State
	//	max_alarm	not set for sezione2State
	//	min_alarm	not set for sezione2State
	//	max_warning	not set for sezione2State
	//	min_warning	not set for sezione2State
	//	delta_t	not set for sezione2State
	//	delta_val	not set for sezione2State
	sezione2state->set_default_properties(sezione2state_prop);
	//	Not Polled
	sezione2state->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(sezione2state);

	//	Attribute : sezione1State
	sezione1StateAttrib	*sezione1state = new sezione1StateAttrib();
	Tango::UserDefaultAttrProp	sezione1state_prop;
	//	description	not set for sezione1State
	//	label	not set for sezione1State
	//	unit	not set for sezione1State
	//	standard_unit	not set for sezione1State
	//	display_unit	not set for sezione1State
	//	format	not set for sezione1State
	//	max_value	not set for sezione1State
	//	min_value	not set for sezione1State
	//	max_alarm	not set for sezione1State
	//	min_alarm	not set for sezione1State
	//	max_warning	not set for sezione1State
	//	min_warning	not set for sezione1State
	//	delta_t	not set for sezione1State
	//	delta_val	not set for sezione1State
	sezione1state->set_default_properties(sezione1state_prop);
	//	Not Polled
	sezione1state->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(sezione1state);

	//	Attribute : buncherState
	buncherStateAttrib	*buncherstate = new buncherStateAttrib();
	Tango::UserDefaultAttrProp	buncherstate_prop;
	//	description	not set for buncherState
	//	label	not set for buncherState
	//	unit	not set for buncherState
	//	standard_unit	not set for buncherState
	//	display_unit	not set for buncherState
	//	format	not set for buncherState
	//	max_value	not set for buncherState
	//	min_value	not set for buncherState
	//	max_alarm	not set for buncherState
	//	min_alarm	not set for buncherState
	//	max_warning	not set for buncherState
	//	min_warning	not set for buncherState
	//	delta_t	not set for buncherState
	//	delta_val	not set for buncherState
	buncherstate->set_default_properties(buncherstate_prop);
	//	Not Polled
	buncherstate->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(buncherstate);

	//	Attribute : sezione2FSHighState
	sezione2FSHighStateAttrib	*sezione2fshighstate = new sezione2FSHighStateAttrib();
	Tango::UserDefaultAttrProp	sezione2fshighstate_prop;
	//	description	not set for sezione2FSHighState
	//	label	not set for sezione2FSHighState
	//	unit	not set for sezione2FSHighState
	//	standard_unit	not set for sezione2FSHighState
	//	display_unit	not set for sezione2FSHighState
	//	format	not set for sezione2FSHighState
	//	max_value	not set for sezione2FSHighState
	//	min_value	not set for sezione2FSHighState
	//	max_alarm	not set for sezione2FSHighState
	//	min_alarm	not set for sezione2FSHighState
	//	max_warning	not set for sezione2FSHighState
	//	min_warning	not set for sezione2FSHighState
	//	delta_t	not set for sezione2FSHighState
	//	delta_val	not set for sezione2FSHighState
	sezione2fshighstate->set_default_properties(sezione2fshighstate_prop);
	//	Not Polled
	sezione2fshighstate->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(sezione2fshighstate);

	//	Attribute : sezione2TSState
	sezione2TSStateAttrib	*sezione2tsstate = new sezione2TSStateAttrib();
	Tango::UserDefaultAttrProp	sezione2tsstate_prop;
	//	description	not set for sezione2TSState
	//	label	not set for sezione2TSState
	//	unit	not set for sezione2TSState
	//	standard_unit	not set for sezione2TSState
	//	display_unit	not set for sezione2TSState
	//	format	not set for sezione2TSState
	//	max_value	not set for sezione2TSState
	//	min_value	not set for sezione2TSState
	//	max_alarm	not set for sezione2TSState
	//	min_alarm	not set for sezione2TSState
	//	max_warning	not set for sezione2TSState
	//	min_warning	not set for sezione2TSState
	//	delta_t	not set for sezione2TSState
	//	delta_val	not set for sezione2TSState
	sezione2tsstate->set_default_properties(sezione2tsstate_prop);
	//	Not Polled
	sezione2tsstate->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(sezione2tsstate);

	//	Attribute : sezione1FSHighState
	sezione1FSHighStateAttrib	*sezione1fshighstate = new sezione1FSHighStateAttrib();
	Tango::UserDefaultAttrProp	sezione1fshighstate_prop;
	//	description	not set for sezione1FSHighState
	//	label	not set for sezione1FSHighState
	//	unit	not set for sezione1FSHighState
	//	standard_unit	not set for sezione1FSHighState
	//	display_unit	not set for sezione1FSHighState
	//	format	not set for sezione1FSHighState
	//	max_value	not set for sezione1FSHighState
	//	min_value	not set for sezione1FSHighState
	//	max_alarm	not set for sezione1FSHighState
	//	min_alarm	not set for sezione1FSHighState
	//	max_warning	not set for sezione1FSHighState
	//	min_warning	not set for sezione1FSHighState
	//	delta_t	not set for sezione1FSHighState
	//	delta_val	not set for sezione1FSHighState
	sezione1fshighstate->set_default_properties(sezione1fshighstate_prop);
	//	Not Polled
	sezione1fshighstate->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(sezione1fshighstate);

	//	Attribute : sezione1TSState
	sezione1TSStateAttrib	*sezione1tsstate = new sezione1TSStateAttrib();
	Tango::UserDefaultAttrProp	sezione1tsstate_prop;
	//	description	not set for sezione1TSState
	//	label	not set for sezione1TSState
	//	unit	not set for sezione1TSState
	//	standard_unit	not set for sezione1TSState
	//	display_unit	not set for sezione1TSState
	//	format	not set for sezione1TSState
	//	max_value	not set for sezione1TSState
	//	min_value	not set for sezione1TSState
	//	max_alarm	not set for sezione1TSState
	//	min_alarm	not set for sezione1TSState
	//	max_warning	not set for sezione1TSState
	//	min_warning	not set for sezione1TSState
	//	delta_t	not set for sezione1TSState
	//	delta_val	not set for sezione1TSState
	sezione1tsstate->set_default_properties(sezione1tsstate_prop);
	//	Not Polled
	sezione1tsstate->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(sezione1tsstate);

	//	Attribute : buncherFSHighState
	buncherFSHighStateAttrib	*buncherfshighstate = new buncherFSHighStateAttrib();
	Tango::UserDefaultAttrProp	buncherfshighstate_prop;
	//	description	not set for buncherFSHighState
	//	label	not set for buncherFSHighState
	//	unit	not set for buncherFSHighState
	//	standard_unit	not set for buncherFSHighState
	//	display_unit	not set for buncherFSHighState
	//	format	not set for buncherFSHighState
	//	max_value	not set for buncherFSHighState
	//	min_value	not set for buncherFSHighState
	//	max_alarm	not set for buncherFSHighState
	//	min_alarm	not set for buncherFSHighState
	//	max_warning	not set for buncherFSHighState
	//	min_warning	not set for buncherFSHighState
	//	delta_t	not set for buncherFSHighState
	//	delta_val	not set for buncherFSHighState
	buncherfshighstate->set_default_properties(buncherfshighstate_prop);
	//	Not Polled
	buncherfshighstate->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(buncherfshighstate);

	//	Attribute : buncherTSState
	buncherTSStateAttrib	*bunchertsstate = new buncherTSStateAttrib();
	Tango::UserDefaultAttrProp	bunchertsstate_prop;
	//	description	not set for buncherTSState
	//	label	not set for buncherTSState
	//	unit	not set for buncherTSState
	//	standard_unit	not set for buncherTSState
	//	display_unit	not set for buncherTSState
	//	format	not set for buncherTSState
	//	max_value	not set for buncherTSState
	//	min_value	not set for buncherTSState
	//	max_alarm	not set for buncherTSState
	//	min_alarm	not set for buncherTSState
	//	max_warning	not set for buncherTSState
	//	min_warning	not set for buncherTSState
	//	delta_t	not set for buncherTSState
	//	delta_val	not set for buncherTSState
	bunchertsstate->set_default_properties(bunchertsstate_prop);
	//	Not Polled
	bunchertsstate->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(bunchertsstate);

	//	Attribute : sezione2FSLowState
	sezione2FSLowStateAttrib	*sezione2fslowstate = new sezione2FSLowStateAttrib();
	Tango::UserDefaultAttrProp	sezione2fslowstate_prop;
	//	description	not set for sezione2FSLowState
	//	label	not set for sezione2FSLowState
	//	unit	not set for sezione2FSLowState
	//	standard_unit	not set for sezione2FSLowState
	//	display_unit	not set for sezione2FSLowState
	//	format	not set for sezione2FSLowState
	//	max_value	not set for sezione2FSLowState
	//	min_value	not set for sezione2FSLowState
	//	max_alarm	not set for sezione2FSLowState
	//	min_alarm	not set for sezione2FSLowState
	//	max_warning	not set for sezione2FSLowState
	//	min_warning	not set for sezione2FSLowState
	//	delta_t	not set for sezione2FSLowState
	//	delta_val	not set for sezione2FSLowState
	sezione2fslowstate->set_default_properties(sezione2fslowstate_prop);
	//	Not Polled
	sezione2fslowstate->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(sezione2fslowstate);

	//	Attribute : sezione1FSLowState
	sezione1FSLowStateAttrib	*sezione1fslowstate = new sezione1FSLowStateAttrib();
	Tango::UserDefaultAttrProp	sezione1fslowstate_prop;
	//	description	not set for sezione1FSLowState
	//	label	not set for sezione1FSLowState
	//	unit	not set for sezione1FSLowState
	//	standard_unit	not set for sezione1FSLowState
	//	display_unit	not set for sezione1FSLowState
	//	format	not set for sezione1FSLowState
	//	max_value	not set for sezione1FSLowState
	//	min_value	not set for sezione1FSLowState
	//	max_alarm	not set for sezione1FSLowState
	//	min_alarm	not set for sezione1FSLowState
	//	max_warning	not set for sezione1FSLowState
	//	min_warning	not set for sezione1FSLowState
	//	delta_t	not set for sezione1FSLowState
	//	delta_val	not set for sezione1FSLowState
	sezione1fslowstate->set_default_properties(sezione1fslowstate_prop);
	//	Not Polled
	sezione1fslowstate->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(sezione1fslowstate);

	//	Attribute : buncherFSLowState
	buncherFSLowStateAttrib	*buncherfslowstate = new buncherFSLowStateAttrib();
	Tango::UserDefaultAttrProp	buncherfslowstate_prop;
	//	description	not set for buncherFSLowState
	//	label	not set for buncherFSLowState
	//	unit	not set for buncherFSLowState
	//	standard_unit	not set for buncherFSLowState
	//	display_unit	not set for buncherFSLowState
	//	format	not set for buncherFSLowState
	//	max_value	not set for buncherFSLowState
	//	min_value	not set for buncherFSLowState
	//	max_alarm	not set for buncherFSLowState
	//	min_alarm	not set for buncherFSLowState
	//	max_warning	not set for buncherFSLowState
	//	min_warning	not set for buncherFSLowState
	//	delta_t	not set for buncherFSLowState
	//	delta_val	not set for buncherFSLowState
	buncherfslowstate->set_default_properties(buncherfslowstate_prop);
	//	Not Polled
	buncherfslowstate->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(buncherfslowstate);


	//	Create a list of static attributes
	create_static_attribute_list(get_class_attr()->get_attr_list());
	/*----- PROTECTED REGION ID(PLCRack3Class::attribute_factory_after) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3Class::attribute_factory_after
}
//--------------------------------------------------------
/**
 *	Method     : PLCRack3Class::pipe_factory()
 *	Description: Create the pipe object(s)
 *                and store them in the pipe list
 */
//--------------------------------------------------------
void PLCRack3Class::pipe_factory()
{
	/*----- PROTECTED REGION ID(PLCRack3Class::pipe_factory_before) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3Class::pipe_factory_before
	/*----- PROTECTED REGION ID(PLCRack3Class::pipe_factory_after) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3Class::pipe_factory_after
}
//--------------------------------------------------------
/**
 *	Method     : PLCRack3Class::command_factory()
 *	Description: Create the command object(s)
 *                and store them in the command list
 */
//--------------------------------------------------------
void PLCRack3Class::command_factory()
{
	/*----- PROTECTED REGION ID(PLCRack3Class::command_factory_before) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3Class::command_factory_before
	//	Call command_factory for inherited class
	Socket2Client_ns::Socket2ClientClass::command_factory();



	/*----- PROTECTED REGION ID(PLCRack3Class::command_factory_after) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3Class::command_factory_after
}

//===================================================================
//	Dynamic attributes related methods
//===================================================================

//--------------------------------------------------------
/**
 * method : 		PLCRack3Class::create_static_attribute_list
 * description : 	Create the a list of static attributes
 *
 * @param	att_list	the created attribute list
 */
//--------------------------------------------------------
void PLCRack3Class::create_static_attribute_list(std::vector<Tango::Attr *> &att_list)
{
	for (unsigned long i=0 ; i<att_list.size() ; i++)
	{
		std::string att_name(att_list[i]->get_name());
		transform(att_name.begin(), att_name.end(), att_name.begin(), ::tolower);
		defaultAttList.push_back(att_name);
	}

	TANGO_LOG_INFO << defaultAttList.size() << " attributes in default list" << std::endl;

	/*----- PROTECTED REGION ID(PLCRack3Class::create_static_att_list) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3Class::create_static_att_list
}


//--------------------------------------------------------
/**
 * method : 		PLCRack3Class::erase_dynamic_attributes
 * description : 	delete the dynamic attributes if any.
 *
 * @param	devlist_ptr	the device list pointer
 * @param	list of all attributes
 */
//--------------------------------------------------------
void PLCRack3Class::erase_dynamic_attributes(const Tango::DevVarStringArray *devlist_ptr, std::vector<Tango::Attr *> &att_list)
{
	Tango::Util *tg = Tango::Util::instance();

	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		Tango::DeviceImpl *dev_impl = tg->get_device_by_name(((std::string)(*devlist_ptr)[i]).c_str());
		PLCRack3 *dev = static_cast<PLCRack3 *> (dev_impl);

		std::vector<Tango::Attribute *> &dev_att_list = dev->get_device_attr()->get_attribute_list();
		std::vector<Tango::Attribute *>::iterator ite_att;
		for (ite_att=dev_att_list.begin() ; ite_att != dev_att_list.end() ; ++ite_att)
		{
			std::string att_name((*ite_att)->get_name_lower());
			if ((att_name == "state") || (att_name == "status"))
				continue;
			std::vector<std::string>::iterator ite_str = find(defaultAttList.begin(), defaultAttList.end(), att_name);
			if (ite_str == defaultAttList.end())
			{
				TANGO_LOG_INFO << att_name << " is a UNWANTED dynamic attribute for device " << (*devlist_ptr)[i] << std::endl;
				Tango::Attribute &att = dev->get_device_attr()->get_attr_by_name(att_name.c_str());
				dev->remove_attribute(att_list[att.get_attr_idx()], true, false);
				--ite_att;
			}
		}
	}
	/*----- PROTECTED REGION ID(PLCRack3Class::erase_dynamic_attributes) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3Class::erase_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method     : PLCRack3Class::get_attr_object_by_name()
 *	Description: returns Tango::Attr * object found by name
 */
//--------------------------------------------------------
Tango::Attr *PLCRack3Class::get_attr_object_by_name(std::vector<Tango::Attr *> &att_list, std::string attname)
{
	std::vector<Tango::Attr *>::iterator it;
	for (it=att_list.begin() ; it<att_list.end() ; ++it)
		if ((*it)->get_name()==attname)
			return (*it);
	//	Attr does not exist
	return NULL;
}


/*----- PROTECTED REGION ID(PLCRack3Class::Additional Methods) ENABLED START -----*/
/* clang-format on */
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	PLCRack3Class::Additional Methods
} //	namespace
