/*----- PROTECTED REGION ID(PLCRack3Class.h) ENABLED START -----*/
/* clang-format on */
//=============================================================================
//
// file :        PLCRack3Class.h
//
// description : Include for the PLCRack3 root class.
//               This class is the singleton class for
//                the PLCRack3 device class.
//               It contains all properties and methods which the
//               PLCRack3 requires only once e.g. the commands.
//
// project :     PLCRack3
//
// This file is part of Tango device class.
//
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
//
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef PLCRack3Class_H
#define PLCRack3Class_H

#include <tango.h>
#include <Socket2ClientClass.h>
#include "PLCRack3.h"

/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	PLCRack3Class.h


namespace PLCRack3_ns
{
/*----- PROTECTED REGION ID(PLCRack3Class::classes for dynamic creation) ENABLED START -----*/
/* clang-format on */

/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	PLCRack3Class::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute sezione2Temp class definition
class sezione2TempAttrib: public Tango::Attr
{
public:
	sezione2TempAttrib():Attr("sezione2Temp",
			Tango::DEV_DOUBLE, Tango::READ) {}
	~sezione2TempAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PLCRack3 *>(dev))->read_sezione2Temp(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PLCRack3 *>(dev))->is_sezione2Temp_allowed(ty);}
};

//	Attribute sezione1Temp class definition
class sezione1TempAttrib: public Tango::Attr
{
public:
	sezione1TempAttrib():Attr("sezione1Temp",
			Tango::DEV_DOUBLE, Tango::READ) {}
	~sezione1TempAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PLCRack3 *>(dev))->read_sezione1Temp(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PLCRack3 *>(dev))->is_sezione1Temp_allowed(ty);}
};

//	Attribute buncherTemp class definition
class buncherTempAttrib: public Tango::Attr
{
public:
	buncherTempAttrib():Attr("buncherTemp",
			Tango::DEV_DOUBLE, Tango::READ) {}
	~buncherTempAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PLCRack3 *>(dev))->read_buncherTemp(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PLCRack3 *>(dev))->is_buncherTemp_allowed(ty);}
};

//	Attribute sezione2State class definition
class sezione2StateAttrib: public Tango::Attr
{
public:
	sezione2StateAttrib():Attr("sezione2State",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {}
	~sezione2StateAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PLCRack3 *>(dev))->read_sezione2State(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<PLCRack3 *>(dev))->write_sezione2State(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PLCRack3 *>(dev))->is_sezione2State_allowed(ty);}
};

//	Attribute sezione1State class definition
class sezione1StateAttrib: public Tango::Attr
{
public:
	sezione1StateAttrib():Attr("sezione1State",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {}
	~sezione1StateAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PLCRack3 *>(dev))->read_sezione1State(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<PLCRack3 *>(dev))->write_sezione1State(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PLCRack3 *>(dev))->is_sezione1State_allowed(ty);}
};

//	Attribute buncherState class definition
class buncherStateAttrib: public Tango::Attr
{
public:
	buncherStateAttrib():Attr("buncherState",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {}
	~buncherStateAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PLCRack3 *>(dev))->read_buncherState(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<PLCRack3 *>(dev))->write_buncherState(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PLCRack3 *>(dev))->is_buncherState_allowed(ty);}
};

//	Attribute sezione2FSHighState class definition
class sezione2FSHighStateAttrib: public Tango::Attr
{
public:
	sezione2FSHighStateAttrib():Attr("sezione2FSHighState",
			Tango::DEV_BOOLEAN, Tango::READ) {}
	~sezione2FSHighStateAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PLCRack3 *>(dev))->read_sezione2FSHighState(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PLCRack3 *>(dev))->is_sezione2FSHighState_allowed(ty);}
};

//	Attribute sezione2TSState class definition
class sezione2TSStateAttrib: public Tango::Attr
{
public:
	sezione2TSStateAttrib():Attr("sezione2TSState",
			Tango::DEV_BOOLEAN, Tango::READ) {}
	~sezione2TSStateAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PLCRack3 *>(dev))->read_sezione2TSState(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PLCRack3 *>(dev))->is_sezione2TSState_allowed(ty);}
};

//	Attribute sezione1FSHighState class definition
class sezione1FSHighStateAttrib: public Tango::Attr
{
public:
	sezione1FSHighStateAttrib():Attr("sezione1FSHighState",
			Tango::DEV_BOOLEAN, Tango::READ) {}
	~sezione1FSHighStateAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PLCRack3 *>(dev))->read_sezione1FSHighState(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PLCRack3 *>(dev))->is_sezione1FSHighState_allowed(ty);}
};

//	Attribute sezione1TSState class definition
class sezione1TSStateAttrib: public Tango::Attr
{
public:
	sezione1TSStateAttrib():Attr("sezione1TSState",
			Tango::DEV_BOOLEAN, Tango::READ) {}
	~sezione1TSStateAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PLCRack3 *>(dev))->read_sezione1TSState(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PLCRack3 *>(dev))->is_sezione1TSState_allowed(ty);}
};

//	Attribute buncherFSHighState class definition
class buncherFSHighStateAttrib: public Tango::Attr
{
public:
	buncherFSHighStateAttrib():Attr("buncherFSHighState",
			Tango::DEV_BOOLEAN, Tango::READ) {}
	~buncherFSHighStateAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PLCRack3 *>(dev))->read_buncherFSHighState(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PLCRack3 *>(dev))->is_buncherFSHighState_allowed(ty);}
};

//	Attribute buncherTSState class definition
class buncherTSStateAttrib: public Tango::Attr
{
public:
	buncherTSStateAttrib():Attr("buncherTSState",
			Tango::DEV_BOOLEAN, Tango::READ) {}
	~buncherTSStateAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PLCRack3 *>(dev))->read_buncherTSState(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PLCRack3 *>(dev))->is_buncherTSState_allowed(ty);}
};

//	Attribute sezione2FSLowState class definition
class sezione2FSLowStateAttrib: public Tango::Attr
{
public:
	sezione2FSLowStateAttrib():Attr("sezione2FSLowState",
			Tango::DEV_BOOLEAN, Tango::READ) {}
	~sezione2FSLowStateAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PLCRack3 *>(dev))->read_sezione2FSLowState(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PLCRack3 *>(dev))->is_sezione2FSLowState_allowed(ty);}
};

//	Attribute sezione1FSLowState class definition
class sezione1FSLowStateAttrib: public Tango::Attr
{
public:
	sezione1FSLowStateAttrib():Attr("sezione1FSLowState",
			Tango::DEV_BOOLEAN, Tango::READ) {}
	~sezione1FSLowStateAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PLCRack3 *>(dev))->read_sezione1FSLowState(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PLCRack3 *>(dev))->is_sezione1FSLowState_allowed(ty);}
};

//	Attribute buncherFSLowState class definition
class buncherFSLowStateAttrib: public Tango::Attr
{
public:
	buncherFSLowStateAttrib():Attr("buncherFSLowState",
			Tango::DEV_BOOLEAN, Tango::READ) {}
	~buncherFSLowStateAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PLCRack3 *>(dev))->read_buncherFSLowState(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PLCRack3 *>(dev))->is_buncherFSLowState_allowed(ty);}
};


/**
 *	The PLCRack3Class singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  PLCRack3Class : public Socket2Client_ns::Socket2ClientClass
#else
class PLCRack3Class : public Socket2Client_ns::Socket2ClientClass
#endif
{
	/*----- PROTECTED REGION ID(PLCRack3Class::Additional DServer data members) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3Class::Additional DServer data members

	public:
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
		//	Method prototypes
		static PLCRack3Class *init(const char *);
		static PLCRack3Class *instance();
		~PLCRack3Class();
		Tango::DbDatum	get_class_property(std::string &);
		Tango::DbDatum	get_default_device_property(std::string &);
		Tango::DbDatum	get_default_class_property(std::string &);

	protected:
		PLCRack3Class(std::string &);
		static PLCRack3Class *_instance;
		void command_factory();
		void attribute_factory(std::vector<Tango::Attr *> &);
		void pipe_factory();
		void write_class_property();
		void set_default_property();
		void get_class_property();
		std::string get_cvstag();
		std::string get_cvsroot();

	private:
		void device_factory(TANGO_UNUSED(const Tango::DevVarStringArray *));
		void create_static_attribute_list(std::vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,std::vector<Tango::Attr *> &);
		std::vector<std::string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(std::vector<Tango::Attr *> &att_list, std::string attname);
};

}	//	End of namespace

#endif   //	PLCRack3_H
