/*----- PROTECTED REGION ID(PLCRack3StateMachine.cpp) ENABLED START -----*/
/* clang-format on */
//=============================================================================
//
// file :        PLCRack3StateMachine.cpp
//
// description : State machine file for the PLCRack3 class
//
// project :     PLCRack3
//
// This file is part of Tango device class.
//
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
//
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

#include "PLCRack3.h"

/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	PLCRack3::PLCRack3StateMachine.cpp

//================================================================
//  States  |  Description
//================================================================


namespace PLCRack3_ns
{
//=================================================
//		Attributes Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method     : PLCRack3::is_sezione2Temp_allowed()
 *	Description: Execution allowed for sezione2Temp attribute
 */
//--------------------------------------------------------
bool PLCRack3::is_sezione2Temp_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for sezione2Temp attribute in read access.
	/*----- PROTECTED REGION ID(PLCRack3::sezione2TempStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3::sezione2TempStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : PLCRack3::is_sezione1Temp_allowed()
 *	Description: Execution allowed for sezione1Temp attribute
 */
//--------------------------------------------------------
bool PLCRack3::is_sezione1Temp_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for sezione1Temp attribute in read access.
	/*----- PROTECTED REGION ID(PLCRack3::sezione1TempStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3::sezione1TempStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : PLCRack3::is_buncherTemp_allowed()
 *	Description: Execution allowed for buncherTemp attribute
 */
//--------------------------------------------------------
bool PLCRack3::is_buncherTemp_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for buncherTemp attribute in read access.
	/*----- PROTECTED REGION ID(PLCRack3::buncherTempStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3::buncherTempStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : PLCRack3::is_sezione2State_allowed()
 *	Description: Execution allowed for sezione2State attribute
 */
//--------------------------------------------------------
bool PLCRack3::is_sezione2State_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for sezione2State attribute in Write access.
	/*----- PROTECTED REGION ID(PLCRack3::sezione2StateStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3::sezione2StateStateAllowed_WRITE

	//	Not any excluded states for sezione2State attribute in read access.
	/*----- PROTECTED REGION ID(PLCRack3::sezione2StateStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3::sezione2StateStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : PLCRack3::is_sezione1State_allowed()
 *	Description: Execution allowed for sezione1State attribute
 */
//--------------------------------------------------------
bool PLCRack3::is_sezione1State_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for sezione1State attribute in Write access.
	/*----- PROTECTED REGION ID(PLCRack3::sezione1StateStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3::sezione1StateStateAllowed_WRITE

	//	Not any excluded states for sezione1State attribute in read access.
	/*----- PROTECTED REGION ID(PLCRack3::sezione1StateStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3::sezione1StateStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : PLCRack3::is_buncherState_allowed()
 *	Description: Execution allowed for buncherState attribute
 */
//--------------------------------------------------------
bool PLCRack3::is_buncherState_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for buncherState attribute in Write access.
	/*----- PROTECTED REGION ID(PLCRack3::buncherStateStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3::buncherStateStateAllowed_WRITE

	//	Not any excluded states for buncherState attribute in read access.
	/*----- PROTECTED REGION ID(PLCRack3::buncherStateStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3::buncherStateStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : PLCRack3::is_sezione2FSHighState_allowed()
 *	Description: Execution allowed for sezione2FSHighState attribute
 */
//--------------------------------------------------------
bool PLCRack3::is_sezione2FSHighState_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for sezione2FSHighState attribute in read access.
	/*----- PROTECTED REGION ID(PLCRack3::sezione2FSHighStateStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3::sezione2FSHighStateStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : PLCRack3::is_sezione2TSState_allowed()
 *	Description: Execution allowed for sezione2TSState attribute
 */
//--------------------------------------------------------
bool PLCRack3::is_sezione2TSState_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for sezione2TSState attribute in read access.
	/*----- PROTECTED REGION ID(PLCRack3::sezione2TSStateStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3::sezione2TSStateStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : PLCRack3::is_sezione1FSHighState_allowed()
 *	Description: Execution allowed for sezione1FSHighState attribute
 */
//--------------------------------------------------------
bool PLCRack3::is_sezione1FSHighState_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for sezione1FSHighState attribute in read access.
	/*----- PROTECTED REGION ID(PLCRack3::sezione1FSHighStateStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3::sezione1FSHighStateStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : PLCRack3::is_sezione1TSState_allowed()
 *	Description: Execution allowed for sezione1TSState attribute
 */
//--------------------------------------------------------
bool PLCRack3::is_sezione1TSState_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for sezione1TSState attribute in read access.
	/*----- PROTECTED REGION ID(PLCRack3::sezione1TSStateStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3::sezione1TSStateStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : PLCRack3::is_buncherFSHighState_allowed()
 *	Description: Execution allowed for buncherFSHighState attribute
 */
//--------------------------------------------------------
bool PLCRack3::is_buncherFSHighState_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for buncherFSHighState attribute in read access.
	/*----- PROTECTED REGION ID(PLCRack3::buncherFSHighStateStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3::buncherFSHighStateStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : PLCRack3::is_buncherTSState_allowed()
 *	Description: Execution allowed for buncherTSState attribute
 */
//--------------------------------------------------------
bool PLCRack3::is_buncherTSState_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for buncherTSState attribute in read access.
	/*----- PROTECTED REGION ID(PLCRack3::buncherTSStateStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3::buncherTSStateStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : PLCRack3::is_sezione2FSLowState_allowed()
 *	Description: Execution allowed for sezione2FSLowState attribute
 */
//--------------------------------------------------------
bool PLCRack3::is_sezione2FSLowState_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for sezione2FSLowState attribute in read access.
	/*----- PROTECTED REGION ID(PLCRack3::sezione2FSLowStateStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3::sezione2FSLowStateStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : PLCRack3::is_sezione1FSLowState_allowed()
 *	Description: Execution allowed for sezione1FSLowState attribute
 */
//--------------------------------------------------------
bool PLCRack3::is_sezione1FSLowState_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for sezione1FSLowState attribute in read access.
	/*----- PROTECTED REGION ID(PLCRack3::sezione1FSLowStateStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3::sezione1FSLowStateStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : PLCRack3::is_buncherFSLowState_allowed()
 *	Description: Execution allowed for buncherFSLowState attribute
 */
//--------------------------------------------------------
bool PLCRack3::is_buncherFSLowState_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for buncherFSLowState attribute in read access.
	/*----- PROTECTED REGION ID(PLCRack3::buncherFSLowStateStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	PLCRack3::buncherFSLowStateStateAllowed_READ
	return true;
}


//=================================================
//		Commands Allowed Methods
//=================================================


/*----- PROTECTED REGION ID(PLCRack3::PLCRack3StateAllowed.AdditionalMethods) ENABLED START -----*/
/* clang-format on */
//	Additional Methods
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	PLCRack3::PLCRack3StateAllowed.AdditionalMethods

}	//	End of namespace
